////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <string>
#include <string_view>
#include <setup.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>
#include <vdr/channels.h>
#include <stringhelpers.h>
#include <livefeatures.h>

#ifdef HAVE_PCRE2
#include <StringMatch.h>
#endif
#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class setactive_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        setactive_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class todel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        todel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    setactive_type setactive;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    todel_type todel;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "(\003\000\000)\003\000\000*\003\000\000+\003\000\000\235\003\000\000\252\003\000\000\257"
  "\003\000\000\264\003\000\000\337\003\000\000\022\005\000\000\032\005\000\000 \005\000\0002\005\000\000z\005\000\000)"
  "\006\000\0001\006\000\0007\006\000\000I\006\000\000R\006\000\000~\006\000\0005\007\000\000d\007\000\000\177\007\000"
  "\000\221\007\000\000\236\010\000\000\253\010\000\000\267\010\000\000\312\010\000\000w\t\000\000x\t\000\000z\t\000\000"
  "{\t\000\000}\t\000\000~\t\000\000\272\t\000\000\315\t\000\000\323\t\000\000\324\t\000\000\232\n\000\000\352\n\000\000"
  "\037\013\000\000R\013\000\000\221\013\000\000\353\013\000\000\365\013\000\000\023\014\000\000,\014\000\000-\014\000"
  "\000.\014\000\0000\014\000\000\222\014\000\000\265\014\000\000\n\015\000\000;\015\000\000\211\015\000\000\347\015\000"
  "\000\015\016\000\000x\016\000\000\223\016\000\000\317\016\000\000\367\016\000\000\004\017\000\000D\017\000\000\177"
  "\017\000\000\240\017\000\000\253\017\000\000\260\017\000\000\263\017\000\000\267\017\000\000\304\017\000\000\345\017"
  "\000\000\375\017\000\000\014\020\000\000/\020\000\0001\020\000\0005\020\000\000;\020\000\000O\020\000\000U\020\000"
  "\000W\020\000\000[\020\000\000_\020\000\000s\020\000\000\204\020\000\000\211\020\000\000\214\020\000\000\216\020\000"
  "\000\236\020\000\000\000\021\000\000^\021\000\000\274\021\000\000\020\022\000\000R\022\000\000\260\022\000\000\276"
  "\022\000\000\366\022\000\000\367\022\000\000\370\022\000\000\021\023\000\0008\023\000\000@\023\000\000F\023\000\000H"
  "\023\000\000J\023\000\000\210\023\000\000\220\023\000\000\226\023\000\000\230\023\000\000\232\023\000\000\352\023\000"
  "\000\360\023\000\000\362\023\000\000\364\023\000\000\371\023\000\0002\024\000\000:\024\000\000@\024\000\000B\024\000"
  "\000C\024\000\000H\024\000\000|\024\000\000\253\024\000\000\333\024\000\000\337\024\000\000\353\024\000\000\363\024"
  "\000\000.\025\000\0007\025\000\000\134\025\000\000e\025\000\000h\025\000\000o\025\000\000p\025\000\000q\025\000\000"
  "\177\025\000\000\200\025\000\000\201\025\000\000\241\025\000\000\247\025\000\000\257\025\000\000\265\025\000\000\307"
  "\025\000\000\311\025\000\000\324\025\000\000\343\025\000\000\344\025\000\000\345\025\000\000\010\026\000\000\016\026"
  "\000\000\026\026\000\000\034\026\000\000.\026\000\000:\026\000\000C\026\000\000J\026\000\000K\026\000\000L\026\000"
  "\000~\026\000\000\225\026\000\000\272\026\000\000\n\027\000\000u\027\000\000\267\027\000\0006\030\000\000H\030\000"
  "\000\212\030\000\000\302\030\000\000\305\030\000\000\310\030\000\000\377\030\000\000\215\031\000\000\276\031\000\000"
  "\376\031\000\000\001\032\000\0004\032\000\0006\032\000\0007\032\000\0008\032\000\0009\032\000\000:\032\000\000;\032"
  "\000\000<\032\000\000=\032\000\000\202\032\000\000\304\032\000\000\307\032\000\000\311\032\000\000\314\032\000\000"
  "\320\032\000\000\324\032\000\000\327\032\000\000\332\032\000\000\347\032\000\000\350\032\000\000\351\032\000\000\363"
  "\032\000\000\002\033\000\000\006\033\000\000\007\033\000\000\010\033\000\000\t\033\000\000\n\033\000\000\n\n\n\n<html"
  ">\n  <head>\n    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - </"
  "title>\n    \n    \n    \n<script>\nconst recordings_tree_creation = ;\nconst recs = [];\nconst rec_ids = Object.crea"
  "te(null)\nrec_ids[\"T\"] = [1, 2]\n\n// Title is the title of the action (like \"play in media player\"), and will be"
  " html encoded here\nfunction RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href=\"'\n  s.a += A\n  s.a += 'r"
  "ecording_'\n  s.a += id\n  s.a += '&sort=&filter=&flat=&history_num_back=\" title=\"'\n  addEncodeHtml(s, Title)\n  s"
  ".a += '\"><img class=\"icon\" src=\"'\n  s.a += Img\n  s.a += '\" /></a>'\n}\nfunction RecordingActionPlaylist(s, id)"
  " {\n  s.a += '<a class=\"hidden-xs\" href=\"playlist.m3u\?recid=recording_'\n  s.a += id\n  s.a += '&sort=&filter=&fl"
  "at=&history_num_back=\" title=\"\" download><img class=\"icon hidden-xs\" src=\"playlist.png\" /></a>'\n}\n\n// do no"
  "t html encode title! will be html encoded here\nfunction addEventRec_r(s, eventid, title, folder, shortText, descript"
  "ion) {\n  var http_params = '&sort=&filter='\n  http_params += encodeURIComponent('')\n  http_params += '&flat=&histo"
  "ry_num_back='\n  addEventRec(s, 'recording_', eventid, http_params, title, folder, shortText, description)\n}\n</scri"
  "pt>\n<script type=\"text/javascript\" src=\"js.html\"></script>\n\n  <script type=\"text/javascript\" src=\"js/live/t"
  "reeview.js\"></script>\n  <script>\n  const tv = new Treeview(\"minus.png\", \"plus.png\", \"folder_open.png\", \"fol"
  "der_closed.png\");\n  </script>\n</head>\n<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\" onpageshow=\"cl"
  "earCheckboxes(document.getElementById('form_recordings'))\">\n  \n  \n  \n  <div class=\"inhalt\">\n    <div class=\""
  "boxheader\"><div><div></div></div></div>\n      \n      <form method=\"post\" name=\"recordings\" id=\"form_recording"
  "s\" action=\"recordings.ecpp\">\n        <div class=\"recordings\">\n          <ul class=\"recordingslist\" style=\"d"
  "isplay: block;\">\n            \n          </ul>\n        </div>\n        <input type=\"hidden\" name=\"sort\" value="
  "\"\">\n        <input type=\"hidden\" name=\"filter\" value=\"\">\n        <input type=\"hidden\" name=\"flat\" value"
  "=\"\">\n        <input type=\"hidden\" name=\"history_num_back\" value=\"\">\n        <div class=\"withmargin hidden-"
  "xs\">\n          <button class=\"red\" type=\"submit\"></button>\n\n        </div>\n      </form>\n  </div>\n</body>"
  "\n</html>\n\n\n\n\n      <li class=\"recording\">\n        <div class=\"recording_item\" onclick = \"tv.Toggle(this, "
  "'fldr_')\">\n        <table><tr>\n                      <td class = \"space\">\n              <img src=\"img/transpar"
  "ent.png\" width=\"px\" height=\"16px\" />\n            </td>\n                    <td class=\"space\">\n            <"
  "img class=\"recording_expander\" src=\"plus.png\" />\n          </td><td class=\"space\">\n            <img class=\"r"
  "ecording_folder\" src=\"folder_closed.png\" />\n          </td>\n            <td class = space>\n              <div c"
  "lass=\"thumb\">\n                <img data-src=\"/tvscraper/\"\n                  class=\"\"\n                />\n   "
  "           </div>\n            </td>\n        <td class=\"recording_folder_name\">\n          \n        </td></tr></t"
  "able>\n        </div>\n        <ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n          \n     "
  "   </ul>\n      </li>\n      <script>\n  recs[]=[]\n  \n</script>\n      <script>\n      rec_ids[\"fldr_\"] = []\n   "
  " </script>\n        <script>\n      document.write(rec_string_d([, , [  ]]))\n      rec_ids[\"fldr_\"] = [, , [  ]]\n"
  "      </script>\n    <script>\n        recs[]=[]\n</script>\n            <li class=\"recording\">\n        <div class"
  "=\"recording_item\" onclick = \"tv.Toggle(this, 'fldr_')\">\n          <table><tr><td class=\"space\">\n            <"
  "img class=\"recording_expander\" src=\"plus.png\" />\n          </td><td class=\"space\">\n            <img class=\"r"
  "ecording_folder\" src=\"folder_closed.png\" />\n          </td><td class=\"recording_folder_name\">\n            \n  "
  "        </td></tr></table>\n        </div>\n        <ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;"
  "\">\n          <script>\n            rec_ids[\"fldr_\"] = [1, 1, [  ]]\n          </script>\n        </ul>\n      </l"
  "i>\n      \n\n<span class=\"label bold\"> </span>\n<a href=\"recordings.html\?sort=&filter=&flat=\"  ></a>\n<span cla"
  "ss=\"sep\">|</span>\n<a href=\"recordings.html\?sort=&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href="
  "\"recordings.html\?sort=duplicates&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?s"
  "ort=&filter=&flat=\" ></a>\n<span class=\"sep\">|</span>\n<span class=\"label bold\">:&nbsp;<input type=\"text\" name"
  "=\"filter\" value=\"\" id=\"filter\" onchange=\"filterRecordings(this, '', '')\" />&nbsp;</span>\n<span class=\"sep\""
  ">|</span>\n<img onclick=\"ExpandAll()\" src=\"\" alt=\"\" />\n<img onclick=\"CollapseAll()\" src=\"\" alt=\"\" />\n<b"
  "r />\n\n\nclass=\"active\"\n\n<a href=\"epginfo.html\?epgid=del_&sort=&filter=&flat=&history_num_back=\" ><img src=\""
  "\" alt=\"\" /></a>\n\n<a href=\"edit_recording.html\?recid=&sort=&filter=&flat=&history_num_back=\"><img src=\"\" alt"
  "=\"\"  /></a>\n\n<!DOCTYPE html>\n<html>\n  <script>\n    history.go(-);\n  </script>\n</html>\n<div class=\"epg_desc"
  "ription\" id=\"del_\">\n  <div class=\"station\">\n    <div class=\"boxheader\"><div><div class=\"caption\"></div></d"
  "iv></div>\n  </div>\n  <div class=\"epg_content\">\n    <form>\n      <div class=\"about_head\"><div><div></div></div"
  "></div>\n      <input type=\"hidden\" name=\"epgid\" value=\"\" >\n      <input type=\"hidden\" name=\"delete_rec\" v"
  "alue=\"confirmed\" >\n      <input type=\"hidden\" name=\"history_num_back\" value=\"\" id=\"history_del_\">\n      <"
  "div class=\"about_left\">\n        <button id=\"confirm_del_\" class=\"green\" type=\"button\" onclick=\"delete_rec_b"
  "ack('', )\"></button>\n      </div>\n      <div class=\"about_right\">\n\n<script>\nfunction cancel_delete() {\n  if "
  "(document.referrer.indexOf(\"epginfo.html\?\") != -1) {\n    history.go(-1);\n  } else {\n    history.go(-);\n  }\n}"
  "\n</script>\n        <button id=\"close_del_\" type=\"button\" class=\"red\" onclick=\"back_depending_referrer(1, )\""
  "></button>\n      </div>\n    </form>\n  </div>\n</div>\n\n\n\n\n\n\n\n\n\n<img data-src=\"img/transparent.png\" heig"
  "ht=\"10px\" />\n<span id=\"icons-\"></span>\n<script class=\"injectIcons\">\ninjectErrorHdSdIcon(\"icons-\", , , \"\""
  ", \"\", \"\", , \"\")\n</script>\n\n\n<img src=\"\" alt=\"on_dvd\"  />\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    setactive(*this, "setactive"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    todel(*this, "todel"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 47 "recordings.ecpp"

std::chrono::time_point<std::chrono::high_resolution_clock> timeStart = std::chrono::high_resolution_clock::now();

reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat<0> targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}

if (request.getMethod() != "POST") history_num_back = 0;  // we can go back in history to this page
else ++history_num_back;  // we have to go back in history to a prev page, to avoid re-send of form data

// create the "current" values of the global request parameters, based on their old values and the current arguments
// basically, this is a bad idea. Pushing "refresh" changes the sort order :( .
// Better: Urls on menue have parameters depending on the current sort option
if (! flat.empty() ) currentFlat = flat;
// sort depends on old sort, and sort parameter
currentSort = LiveSetup().GetLastSortingMode();
if (currentSort.empty() ) currentFlat == "true"?currentSort = "errorsts":currentSort = "datedesc";
if (!sort.empty()) {
  if (sort == "date")
    currentSort = (currentSort == "datedesc") ? "dateasc" : "datedesc";
  else if (sort == "datedesc" || sort == "dateasc") currentSort = sort;
  else if (sort == "name")
    currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
  else if (sort == "nameasc" || sort == "namedesc") currentSort = sort;
  else if (sort == "errors")
    currentSort = (currentSort == "errorsts") ? "errorsdur" : "errorsts";
  else if (sort == "errorsts" || sort == "errorsdur") currentSort = sort;
  else if (sort == "duplicates")
    currentSort = sort;
  LiveSetup().SetLastSortingMode(currentSort);
}
currentFilter = filter;

pageTitle = tr("Recordings");

deleteResult = "";
if (!todel.empty()) {
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  deletions.push_back(todel);
}
for (auto it = deletions.begin(); it != deletions.end(); ++it) {
  if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
    RemoveRecordingTask task(*it);
    LiveTaskManager().Execute(task);
/*
    if (!task.Result())
    deleteResult += std::string() + tr("ERROR:") + " " + task.Error() + "<br/>";
    else
*/
    if (task.Result()) {
      cToSvConcat delRec(tr("Deleted recording:"), " ");
      delRec.appendReplace(task.RecName(), "~", "/");
      delRec << "<br/>";
      deleteResult += std::string(delRec);
    }
  }
  else {
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  }
}
deletions.clear();

int FreeMB, UsedMB;
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));

RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());

// get data for all open nodes
std::vector<int> available_recs;
std::string openTreeNodes;
if (request.hasCookie("VDR-Live-Recordings-Tree-Open-Nodes")) {
  openTreeNodes = request.getCookie("VDR-Live-Recordings-Tree-Open-Nodes");
//  isyslog("live: VDR-Live-Recordings-Tree-Open-Nodes = %s", openTreeNodes.c_str());
}
cToSvConcat<0> recording_item;
recording_item.reserve(25000);

#if TNTVERSION >= 30000
const char *TNT_ARRAY = "[]";
#else
const char *TNT_ARRAY = "";
#endif


  // <& pageelems.doc_type ...
  { 
#line 139 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 139 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 143 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 144 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 144 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 145 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 145 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 146 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 146 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n<script>\nconst recordings_tree_creation = 
#line 148 "recordings.ecpp"
  reply.sout() << ( cToSvInt(recordingsTree->getCreationTimestamp() ) );
  reply.out() << _tntChunks[8]; // ;\nconst recs = [];\nconst rec_ids = Object.create(null)\nrec_ids["T"] = [1, 2]\n\n// Title is the title of the action (like "play in media player"), and will be html encoded here\nfunction RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href="'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&sort=
#line 159 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[9]; // &filter=
#line 159 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[10]; // &flat=
#line 159 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[11]; // &history_num_back=
#line 159 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[12]; // " title="'\n  addEncodeHtml(s, Title)\n  s.a += '"><img class="icon" src="
#line 161 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[13]; // '\n  s.a += Img\n  s.a += '" /></a>'\n}\nfunction RecordingActionPlaylist(s, id) {\n  s.a += '<a class="hidden-xs" href="playlist.m3u\?recid=recording_'\n  s.a += id\n  s.a += '&sort=
#line 168 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[14]; // &filter=
#line 168 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[15]; // &flat=
#line 168 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[16]; // &history_num_back=
#line 168 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[17]; // " title="
#line 168 "recordings.ecpp"
  reply.sout() << (tr("Stream this recording into media player."));
  reply.out() << _tntChunks[18]; // " download><img class="icon hidden-xs" src="
#line 168 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[19]; // playlist.png" /></a>'\n}\n\n// do not html encode title! will be html encoded here\nfunction addEventRec_r(s, eventid, title, folder, shortText, description) {\n  var http_params = '&sort=
#line 173 "recordings.ecpp"
  reply.sout() << ( sort );
  reply.out() << _tntChunks[20]; // &filter='\n  http_params += encodeURIComponent('
#line 174 "recordings.ecpp"
  reply.sout() << ( filter );
  reply.out() << _tntChunks[21]; // ')\n  http_params += '&flat=
#line 175 "recordings.ecpp"
  reply.sout() << ( flat );
  reply.out() << _tntChunks[22]; // &history_num_back=
#line 175 "recordings.ecpp"
  reply.sout() << ( history_num_back+1 );
  reply.out() << _tntChunks[23]; // '\n  addEventRec(s, 'recording_', eventid, http_params, title, folder, shortText, description)\n}\n</script>\n<script type="text/javascript" src="js.html"></script>\n\n  <script type="text/javascript" src="js/live/treeview.js"></script>\n  <script>\n  const tv = new Treeview("
#line 183 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[24]; // minus.png", "
#line 183 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[25]; // plus.png", "
#line 183 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[26]; // folder_open.png", "
#line 183 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[27]; // folder_closed.png");\n  </script>\n</head>\n<body onload="adjustHeader()" onresize="adjustHeader()" onpageshow="clearCheckboxes(document.getElementById('form_recordings'))">\n  
  // <& pageelems.logo ...
  { 
#line 187 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 187 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[28]; // \n
#line 188 "recordings.ecpp"

const char *active_r;
if (flat == "true") active_r = "recordings_flat";
else active_r = "recordings";

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[29]; //   
  // <& menu ...
  { 
#line 195 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 195 "recordings.ecpp"
    _tnt_cq5.add( "active", (active_r));
#line 195 "recordings.ecpp"
    _tnt_cq5.add( "component", "recordings.delete_error");
#line 195 "recordings.ecpp"
    _tnt_cq5.add( "filter", (filter));
#line 195 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[30]; // \n
#line 196 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[31]; //   
  // <& menu ...
  { 
#line 199 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 199 "recordings.ecpp"
    _tnt_cq6.add( "active", (active_r));
#line 199 "recordings.ecpp"
    _tnt_cq6.add( "component", "recordings.sort_options");
#line 199 "recordings.ecpp"
    _tnt_cq6.add( "filter", (filter));
#line 199 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[32]; // \n
#line 200 "recordings.ecpp"

}

  reply.out() << _tntChunks[33]; //   <div class="inhalt">\n    <div class="boxheader"><div><div>
#line 204 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[34]; // </div></div></div>\n
#line 205 "recordings.ecpp"

    int rec_cnt;
    {
      LOCK_RECORDINGS_READ;
      rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
    }
    if (rec_cnt == 0) {

  reply.out() << _tntChunks[35]; //       
#line 213 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[36]; // \n
#line 214 "recordings.ecpp"

    } else {
      uintptr_t irecording_item = (uintptr_t)&recording_item;
      RecordingsItemDirPtr recItemRoot = recordingsTree->getRoot();
      uintptr_t iRecItemRoot = (uintptr_t)&recItemRoot;
      uintptr_t iRecordingsTree = (uintptr_t)&recordingsTree;
      uintptr_t iOpenTreeNodes = (uintptr_t)&openTreeNodes;
      uintptr_t iAvailable_recs = (uintptr_t)&available_recs;

  reply.out() << _tntChunks[37]; //       <form method="post" name="recordings" id="form_recordings" action="recordings.ecpp">\n        <div class="recordings">\n          <ul class="recordingslist" style="display: block;">\n            
  // <& recordings.recordings_item ...
  { 
#line 226 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 226 "recordings.ecpp"
    _tnt_cq7.add( "iAvailable_recs", (iAvailable_recs));
#line 226 "recordings.ecpp"
    _tnt_cq7.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 226 "recordings.ecpp"
    _tnt_cq7.add( "iRecItem", (iRecItemRoot));
#line 226 "recordings.ecpp"
    _tnt_cq7.add( "iRecordingsTree", (iRecordingsTree));
#line 226 "recordings.ecpp"
    _tnt_cq7.add( "irecording_item", (irecording_item));
#line 226 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[38]; // \n          </ul>\n        </div>\n        <input type="hidden" name="sort" value="
#line 229 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[39]; // ">\n        <input type="hidden" name="filter" value="
#line 230 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[40]; // ">\n        <input type="hidden" name="flat" value="
#line 231 "recordings.ecpp"
  reply.sout() << ( currentFlat );
  reply.out() << _tntChunks[41]; // ">\n        <input type="hidden" name="history_num_back" value="
#line 232 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[42]; // ">\n        <div class="withmargin hidden-xs">\n          <button class="red" type="submit">
#line 234 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[43]; // </button>\n
  reply.out() << _tntChunks[44]; // \n        </div>\n      </form>\n
#line 238 "recordings.ecpp"

    }
std::chrono::duration<double> timeNeeded = std::chrono::high_resolution_clock::now() - timeStart;
dsyslog("live, time recordings.ecpp: %f", timeNeeded.count());

  reply.out() << _tntChunks[45]; //   </div>\n</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[46]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[47]; // \n
  reply.out() << _tntChunks[48]; // \n\n
  reply.out() << _tntChunks[95]; // \n
  reply.out() << _tntChunks[96]; // \n
  reply.out() << _tntChunks[131]; // \n
  reply.out() << _tntChunks[132]; // \n
  reply.out() << _tntChunks[134]; // \n
  reply.out() << _tntChunks[135]; // \n
  reply.out() << _tntChunks[144]; // \n
  reply.out() << _tntChunks[145]; // \n
  reply.out() << _tntChunks[154]; // \n
  reply.out() << _tntChunks[155]; // \n
  reply.out() << _tntChunks[174]; // \n\n
  reply.out() << _tntChunks[175]; // \n
  reply.out() << _tntChunks[192]; // \n
  reply.out() << _tntChunks[193]; // \n
  reply.out() << _tntChunks[198]; // \n
  reply.out() << _tntChunks[199]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t iRecItem = qparam.get< uintptr_t >("iRecItem", ( 0));
uintptr_t irecording_item = qparam.get< uintptr_t >("irecording_item", ( 0));
uintptr_t iRecordingsTree = qparam.get< uintptr_t >("iRecordingsTree", ( 0));
uintptr_t iOpenTreeNodes = qparam.get< uintptr_t >("iOpenTreeNodes", ( 0));
uintptr_t iAvailable_recs = qparam.get< uintptr_t >("iAvailable_recs", ( 0));
std::string parentIdHash = qparam.get< std::string >("parentIdHash");
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 259 "recordings.ecpp"

// define sort order, and reverse (for recordings)
// use current sort order and selected sort option for that
bool reverse = false;
eSortOrder sortOrder = eSortOrder::name; // default
if (currentSort.compare(0, 4,  "date"  , 4) == 0) sortOrder = eSortOrder::date;
if (currentSort.compare(0, 6,  "errors", 6) == 0) sortOrder = eSortOrder::errors;
if (currentSort.compare(0, 8,  "errorsdur", 8) == 0) sortOrder = eSortOrder::durationDeviation;
if (currentSort.compare(0, 10, "duplicates", 10) == 0) sortOrder = eSortOrder::duplicatesLanguage;
if (currentSort == "datedesc" || currentSort == "namedesc") reverse = true;
// get rec item of this (current) dir
RecordingsItemDirPtr recItemThisDir = *(static_cast<RecordingsItemDirPtr *>((void *)iRecItem) );
RecordingsTreePtr recordingsTree = *(static_cast<RecordingsTreePtr *>((void *)iRecordingsTree) );
cToSvConcat<0> *recording_item = static_cast<cToSvConcat<0> *>((void *)irecording_item );
std::string openTreeNodes= *(static_cast<std::string *>((void *)iOpenTreeNodes) );
std::vector<int> available_recs = *(static_cast<std::vector<int> *>((void *)iAvailable_recs) );
int level = recItemThisDir->Level();


std::vector<RecordingsItemRecPtr> recItems;
const std::vector<RecordingsItemRecPtr> *recItemsC = NULL;

// data for dirs, and loop over dirs
const std::vector<RecordingsItemDirPtr> *dirItems = recItemThisDir->getDirs();
std::vector<RecordingsItemDirPtr>::const_iterator dirIterS, dirIterE, dirIter;
int direction; // for dirs
if (currentFlat != "true") {
  if (currentSort != "duplicates") {
// list of subdirs
    if (!recItemThisDir->dirEntriesSorted() && currentSort == "namedesc") {
// reverse loop over subdirs
      dirIterS = dirItems->end();
      dirIterE = dirItems->begin();
      direction = 0;
    } else {
// forward loop over subdirs
      dirIterS = dirItems->begin();
      dirIterE = dirItems->end();
      direction = 1;
    }
    for (dirIter = dirIterS; dirIter != dirIterE; std::advance(dirIter, direction) ) {
      if(direction == 0) dirIter--;
// this is the loop over the subdirs
// each subdir is a node, which can be expanded (or not)
// each subdir has an identifier in <ul> tag: fldr_<$ idHash $>
      RecordingsItemDirPtr recItem = *dirIter;

      /* search trough directory for new recordings */
      bool newR = false;
      if ( LiveSetup().GetMarkNewRec() ) newR = recItem->checkNew();
// calculate idHash: uniquely defines this node
      cToSvXxHash32 idHash(cToSvConcat(parentIdHash, recItem->Name()));
      iRecItem = (uintptr_t)&recItem;
  
  reply.out() << _tntChunks[49]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 314 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[50]; // ')">\n        <table><tr>\n          
#line 316 "recordings.ecpp"
 if(level > 0) { 
  reply.out() << _tntChunks[51]; //             <td class = "space">\n              <img src="img/transparent.png" width="
#line 318 "recordings.ecpp"
  reply.sout() << ( 16*level );
  reply.out() << _tntChunks[52]; // px" height="16px" />\n            </td>\n          
#line 320 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[53]; //           <td class="space">\n            <img class="recording_expander" src="
#line 322 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[54]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 324 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[55]; // folder_closed.png" />\n          </td>\n
#line 326 "recordings.ecpp"
         if (!recItem->scraperImage().path.empty() ) {

  reply.out() << _tntChunks[56]; //             <td class = space>\n              <div class="thumb">\n                <img data-src="/tvscraper/
#line 329 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().path );
  reply.out() << _tntChunks[57]; // "\n                  class="
#line 330 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().width > recItem->scraperImage().height?"thumb":"thumbpt" );
  reply.out() << _tntChunks[58]; // "\n                />\n              </div>\n            </td>\n
#line 334 "recordings.ecpp"
         }

  reply.out() << _tntChunks[59]; //         <td class="recording_folder_name
#line 335 "recordings.ecpp"
  reply.sout() << ( (newR ? "_new" : "") );
  reply.out() << _tntChunks[60]; // ">\n          
#line 336 "recordings.ecpp"
  reply.sout() << ( recItem->Name() );
  reply.out() << _tntChunks[61]; // \n        </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 339 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[62]; // " class="recordingslist" style="display: none;">\n          
  // <& recordings.recordings_item ...
  { 
#line 340 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 340 "recordings.ecpp"
    _tnt_cq8.add( "iAvailable_recs", (iAvailable_recs));
#line 340 "recordings.ecpp"
    _tnt_cq8.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 340 "recordings.ecpp"
    _tnt_cq8.add( "iRecItem", (iRecItem));
#line 340 "recordings.ecpp"
    _tnt_cq8.add( "iRecordingsTree", (iRecordingsTree));
#line 340 "recordings.ecpp"
    _tnt_cq8.add( "irecording_item", (irecording_item));
#line 340 "recordings.ecpp"
    _tnt_cq8.add( "parentIdHash", (idHash));
#line 340 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[63]; // \n        </ul>\n      </li>\n      
#line 343 "recordings.ecpp"

    } // end of loop over subdirs
// now the items
    recItemsC = recItemThisDir->getRecordings(sortOrder);
    if (recItemThisDir->recEntriesSorted() ) reverse = false;
  } // end if (currentSort != "duplicates")
} else {
// here we prepare the items in case of a flat list, no folders
  if (currentSort != "duplicates") {
    recItems.clear();
    size_t max_items = 100;
    if (reverse) {
      reverse = false;
      std::vector<RecordingsItemRecPtr>::const_iterator recIterFirst = recordingsTree->allRecordings(sortOrder)->begin();
      std::vector<RecordingsItemRecPtr>::const_iterator recIterLast  = recordingsTree->allRecordings(sortOrder)->end();
      for (; recIterFirst != recIterLast;) {
        --recIterLast;
        RecordingsItemRecPtr recItem = *recIterLast;
        if (!recItem->matchesFilter(currentFilter)) continue;
        recItems.push_back(recItem);
        if (recItems.size() >= max_items) break;
      }
     } else {
      for (const RecordingsItemRecPtr &rPtr: *recordingsTree->allRecordings(sortOrder) ) {
        if (!rPtr->matchesFilter(currentFilter)) continue;
        recItems.push_back(rPtr);
        if (recItems.size() >= max_items) break;
      }
    }
//    recItemsC = recordingsTree->allRecordings(sortOrder);
    recItemsC = &recItems;
  } else {
    recItems.clear();
    addDuplicateRecordingsSd(recItems, recordingsTree);
    addDuplicateRecordingsLang(recItems, recordingsTree);
    addDuplicateRecordingsNoSd(recItems, recordingsTree);
    recItemsC = &recItems;
  }
}
// do we have to get/write the recording details?
// we have to, if currentFlat == true || level == 0 || this folder is open (cookie)
bool write_recs = level == 0 || currentFlat == "true";
if (!write_recs && recItemsC) {
// check: is this folder open (cookie)?
  auto equal_fldf = [parentIdHash](cSv f) { return f.compare(5, std::string_view::npos, parentIdHash) == 0; };
  cSplit splitOpenTreeNodes(openTreeNodes, ',');
  write_recs = std::find_if(splitOpenTreeNodes.begin(), splitOpenTreeNodes.end(), equal_fldf) != splitOpenTreeNodes.end();
}
if (write_recs && recItemsC) {
// in case of duplicates, and not flat, the recItemsC is not available
  
  reply.out() << _tntChunks[64]; // <script>\n  
#line 395 "recordings.ecpp"

  std::chrono::time_point<std::chrono::high_resolution_clock> timeStart_recs = std::chrono::high_resolution_clock::now();
  for (const RecordingsItemRecPtr &rPtr: *recItemsC) {
    recording_item->clear();
    rPtr->AppendAsJSArray(*recording_item);
  
  reply.out() << _tntChunks[65]; // recs[
#line 401 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(rPtr->IdI())));
  reply.out() << _tntChunks[66]; // ]=[
#line 401 "recordings.ecpp"
  reply.out() << ( recording_item->c_str() );
  reply.out() << _tntChunks[67]; // ]\n  
#line 402 "recordings.ecpp"

  }
  std::chrono::duration<double> timeNeeded_recs = std::chrono::high_resolution_clock::now() - timeStart_recs;
  dsyslog("live, time recordings.ecpp recs lv 0: %f", timeNeeded_recs.count());
  
  reply.out() << _tntChunks[68]; // \n</script>\n  
#line 409 "recordings.ecpp"

}
if (currentSort != "duplicates" || currentFlat == "true") {
  if (recItemsC->empty() ) { 
  reply.out() << _tntChunks[69]; //     <script>\n      rec_ids["fldr_
#line 414 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[70]; // "] = []\n    </script>\n  
#line 416 "recordings.ecpp"
 } else {
    bool first = true;
//    const char *displayFolder = currentFlat == "true"?"1":"0";
    const char *displayFolder = "1";
    recording_item->clear();
    RecordingsItemRec::AppendAsJSArray(*recording_item, recItemsC->begin(), recItemsC->end(), first, currentFilter, reverse);
    
  reply.out() << _tntChunks[71]; //       <script>\n
#line 424 "recordings.ecpp"
   if (level == 0) {

  reply.out() << _tntChunks[72]; //       document.write(rec_string_d([
#line 425 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[73]; // , 
#line 425 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[74]; // , [ 
#line 425 "recordings.ecpp"
  reply.out() << ( recording_item->c_str() );
  reply.out() << _tntChunks[75]; //  ]]))\n
#line 426 "recordings.ecpp"
   } else {

  reply.out() << _tntChunks[76]; //       rec_ids["fldr_
#line 427 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[77]; // "] = [
#line 427 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[78]; // , 
#line 427 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[79]; // , [ 
#line 427 "recordings.ecpp"
  reply.out() << ( recording_item->c_str() );
  reply.out() << _tntChunks[80]; //  ]]\n
#line 428 "recordings.ecpp"
   }

  reply.out() << _tntChunks[81]; //       </script>\n    
#line 430 "recordings.ecpp"

  }
} else {
// duplicates
  for (int i = 0; i < 3; i++) {
    recItems.clear();
    std::string nodeName;
    if (i == 0) {
      addDuplicateRecordingsSd(recItems, recordingsTree);
      nodeName = tr("Duplicates identified by tvscraper");
    } else if (i == 1) {
      addDuplicateRecordingsLang(recItems, recordingsTree);
      nodeName = tr("Duplicates, with different languages");
    } else if (i == 2) {
      addDuplicateRecordingsNoSd(recItems, recordingsTree);
      nodeName = tr("Duplicates not identified by tvscraper");
    }
    if (!recItems.empty() ) {
      cToSvXxHash32 idHash(nodeName);
// do we have to get/write the recording details?
// check: is this folder open (cookie)?
      cSv idHash_sv = idHash;
      auto equal_fldf = [idHash_sv](cSv f) { return f.compare(5, std::string_view::npos, idHash_sv) == 0; };
      cSplit splitOpenTreeNodes(openTreeNodes, ',');
      if (std::find_if(splitOpenTreeNodes.begin(), splitOpenTreeNodes.end(), equal_fldf) != splitOpenTreeNodes.end()) {
        
  reply.out() << _tntChunks[82]; // <script>\n        
#line 457 "recordings.ecpp"

        for (const RecordingsItemRecPtr &rPtr: recItems) {
          recording_item->clear();
          rPtr->AppendAsJSArray(*recording_item);
          
  reply.out() << _tntChunks[83]; // recs[
#line 462 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(rPtr->IdI())));
  reply.out() << _tntChunks[84]; // ]=[
#line 462 "recordings.ecpp"
  reply.out() << ( recording_item->c_str() );
  reply.out() << _tntChunks[85]; // ]\n
#line 463 "recordings.ecpp"
       }

  reply.out() << _tntChunks[86]; // </script>\n      
#line 465 "recordings.ecpp"

      }
      bool first = true;
      recording_item->clear();
      RecordingsItemRec::AppendAsJSArray(*recording_item, recItems.begin(), recItems.end(), first, currentFilter, false);
      
  reply.out() << _tntChunks[87]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 472 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[88]; // ')">\n          <table><tr><td class="space">\n            <img class="recording_expander" src="
#line 474 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[89]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 476 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[90]; // folder_closed.png" />\n          </td><td class="recording_folder_name">\n            
#line 478 "recordings.ecpp"
  reply.sout() << ( nodeName );
  reply.out() << _tntChunks[91]; // \n          </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 481 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[92]; // " class="recordingslist" style="display: none;">\n          <script>\n            rec_ids["fldr_
#line 483 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[93]; // "] = [1, 1, [ 
#line 483 "recordings.ecpp"
  reply.out() << ( recording_item->c_str() );
  reply.out() << _tntChunks[94]; //  ]]\n          </script>\n        </ul>\n      </li>\n      
#line 487 "recordings.ecpp"

    }
  }
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 496 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[97]; // <span class="label bold">
#line 497 "recordings.ecpp"
  reply.sout() << ( tr("Sort:") );
  reply.out() << _tntChunks[98]; //  </span>\n<a href="recordings.html\?sort=
#line 498 "recordings.ecpp"
  reply.sout() << ( (currentSort == "nameasc") ? "namedesc" : "nameasc");
  reply.out() << _tntChunks[99]; // &filter=
#line 498 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[100]; // &flat=
#line 498 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[101]; // " 
  // <& setactive ...
  { 
#line 498 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 498 "recordings.ecpp"
    _tnt_cq9.add( "current", "name");
#line 498 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[102]; //  >
#line 498 "recordings.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[103]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 500 "recordings.ecpp"
  reply.sout() << ( (currentSort == "datedesc") ? "dateasc" : "datedesc");
  reply.out() << _tntChunks[104]; // &filter=
#line 500 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[105]; // &flat=
#line 500 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[106]; // " 
  // <& setactive ...
  { 
#line 500 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 500 "recordings.ecpp"
    _tnt_cq10.add( "current", "date");
#line 500 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[107]; //  >
#line 500 "recordings.ecpp"
  reply.sout() << ( tr("Date") );
  reply.out() << _tntChunks[108]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=duplicates&filter=
#line 502 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[109]; // &flat=
#line 502 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[110]; // " 
  // <& setactive ...
  { 
#line 502 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 502 "recordings.ecpp"
    _tnt_cq11.add( "current", "duplicates");
#line 502 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[111]; //  >
#line 502 "recordings.ecpp"
  reply.sout() << ( tr("Duplicates") );
  reply.out() << _tntChunks[112]; // </a>\n
#line 503 "recordings.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[113]; // <span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 507 "recordings.ecpp"
  reply.sout() << ( (currentSort == "errorsts") ? "errorsdur" : "errorsts" );
  reply.out() << _tntChunks[114]; // &filter=
#line 507 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[115]; // &flat=
#line 507 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[116]; // " 
  // <& setactive ...
  { 
#line 507 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 507 "recordings.ecpp"
    _tnt_cq12.add( "current", "errors");
#line 507 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[117]; // >
#line 507 "recordings.ecpp"
  reply.sout() << ( tr("Errors") );
  reply.out() << _tntChunks[118]; // </a>\n
#line 508 "recordings.ecpp"

#endif
#ifdef HAVE_PCRE2

  reply.out() << _tntChunks[119]; // <span class="sep">|</span>\n<span class="label bold">
#line 513 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[120]; // :&nbsp;<input type="text" name="filter" value="
#line 513 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[121]; // " id="filter" onchange="filterRecordings(this, '
#line 513 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[122]; // ', '
#line 513 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[123]; // ')" />&nbsp;
  // <& tooltip.help ...
  { 
#line 513 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 513 "recordings.ecpp"
    _tnt_cq13.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 513 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[124]; // </span>\n
#line 514 "recordings.ecpp"

#endif
if (currentFlat != "true") {

  reply.out() << _tntChunks[125]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 519 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << _tntChunks[126]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 519 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 519 "recordings.ecpp"
    _tnt_cq14.add( "text", (tr("Expand all folders")));
#line 519 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[127]; // />\n<img onclick="CollapseAll()" src="
#line 520 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << _tntChunks[128]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 520 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 520 "recordings.ecpp"
    _tnt_cq15.add( "text", (tr("Collapse all folders")));
#line 520 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[129]; // />\n
#line 521 "recordings.ecpp"

}

  reply.out() << _tntChunks[130]; // <br />\n
#line 525 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::setactive_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::setactive " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string current = qparam.get< std::string >("current");
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 533 "recordings.ecpp"

if (currentSort.compare(0, current.length(), current) == 0) { 
  reply.out() << _tntChunks[133]; // class="active"
#line 534 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 546 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[136]; // <a href="epginfo.html\?epgid=del_
#line 546 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[137]; // &sort=
#line 546 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[138]; // &filter=
#line 546 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[139]; // &flat=
#line 546 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[140]; // &history_num_back=
#line 546 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[141]; // " 
  // <& tooltip.hint ...
  { 
#line 546 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 546 "recordings.ecpp"
    _tnt_cq16.add( "text", (tr("Delete this recording from hard disc!")));
#line 546 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[142]; // ><img src="
#line 546 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[143]; // " alt="" /></a>
#line 546 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 558 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[146]; // <a href="edit_recording.html\?recid=
#line 558 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[147]; // &sort=
#line 558 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[148]; // &filter=
#line 558 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[149]; // &flat=
#line 558 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[150]; // &history_num_back=
#line 558 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[151]; // "><img src="
#line 558 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[152]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 558 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 558 "recordings.ecpp"
    _tnt_cq17.add( "text", (tr("Edit recording")));
#line 558 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[153]; //  /></a>
#line 558 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::todel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::todel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string todel = qparam.get< std::string >("todel");
std::string confirmed = qparam.get< std::string >("confirmed");
std::string history_num_back = qparam.get< std::string >("history_num_back");
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 568 "recordings.ecpp"

  RecordingsManagerPtr recordings = LiveRecordingsManager();
  const cRecording *recording = recordings->GetByMd5Hash(todel);
  if (recording == nullptr)
    throw HtmlError(tr("Couldn't find recording or no recordings available"));
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  if (confirmed == "confirmed") {
    RemoveRecordingTask task(todel);
    LiveTaskManager().Execute(task);

  reply.out() << _tntChunks[156]; // <!DOCTYPE html>\n<html>\n  <script>\n    history.go(-
#line 582 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[157]; // );\n  </script>\n</html>\n
#line 585 "recordings.ecpp"
  } else {

  reply.out() << _tntChunks[158]; // <div class="epg_description" id="del_
#line 586 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[159]; // ">\n  <div class="station">\n    <div class="boxheader"><div><div class="caption">
#line 588 "recordings.ecpp"
  reply.sout() << ( tr("Delete recordings") );
  reply.out() << _tntChunks[160]; // </div></div></div>\n  </div>\n  <div class="epg_content">\n    <form>\n      <div class="about_head"><div><div>
#line 592 "recordings.ecpp"
  reply.sout() << ( cSv(cToSvFormated(tr("Delete recording \"%s\"?"), recording->Name()?recording->Name():"No recording name available")) );
  reply.out() << _tntChunks[161]; // </div></div></div>\n      <input type="hidden" name="epgid" value="
#line 593 "recordings.ecpp"
  reply.sout() << (todel);
  reply.out() << _tntChunks[162]; // " >\n      <input type="hidden" name="delete_rec" value="confirmed" >\n      <input type="hidden" name="history_num_back" value="
#line 595 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[163]; // " id="history_del_
#line 595 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[164]; // ">\n      <div class="about_left">\n        <button id="confirm_del_
#line 597 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[165]; // " class="green" type="button" onclick="delete_rec_back('
#line 597 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[166]; // ', 
#line 597 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[167]; // )">
#line 597 "recordings.ecpp"
  reply.sout() << ( tr("Delete"));
  reply.out() << _tntChunks[168]; // </button>\n      </div>\n      <div class="about_right">\n
  reply.out() << _tntChunks[169]; // \n<script>\nfunction cancel_delete() {\n  if (document.referrer.indexOf("epginfo.html\?") != -1) {\n    history.go(-1);\n  } else {\n    history.go(-
#line 606 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[170]; // );\n  }\n}\n</script>\n        <button id="close_del_
#line 610 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[171]; // " type="button" class="red" onclick="back_depending_referrer(1, 
#line 610 "recordings.ecpp"
  reply.sout() << (history_num_back );
  reply.out() << _tntChunks[172]; // )">
#line 610 "recordings.ecpp"
  reply.sout() << ( tr("Cancel") );
  reply.out() << _tntChunks[173]; // </button>\n      </div>\n    </form>\n  </div>\n</div>\n
#line 615 "recordings.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 630 "recordings.ecpp"
   if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  // <& pageelems.ajax_action_href ...
  { 
#line 631 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 631 "recordings.ecpp"
    _tnt_cq18.add( "action", "play_recording");
#line 631 "recordings.ecpp"
    _tnt_cq18.add( "alt", "");
#line 631 "recordings.ecpp"
    _tnt_cq18.add( "image", "play.png");
#line 631 "recordings.ecpp"
    _tnt_cq18.add( "param", (id));
#line 631 "recordings.ecpp"
    _tnt_cq18.add( "tip", (tr("play this recording")));
#line 631 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[176]; // \n
#line 632 "recordings.ecpp"
   }

  // <& pageelems.hls_recording ...
  { 
#line 633 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 633 "recordings.ecpp"
    _tnt_cq19.add( "recId", (id));
#line 633 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_recording"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[177]; // \n
  // <& pageelems.m3u_playlist_recording ...
  { 
#line 634 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 634 "recordings.ecpp"
    _tnt_cq20.add( "recid", (id));
#line 634 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[178]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 635 "recordings.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 635 "recordings.ecpp"
    _tnt_cq21.add( "s_IMDB_ID", (s_IMDB_ID));
#line 635 "recordings.ecpp"
    _tnt_cq21.add( "title", (title));
#line 635 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[179]; // \n
  // <& recordings.edit_rec ...
  { 
#line 636 "recordings.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 636 "recordings.ecpp"
    _tnt_cq22.add( "filter", (filter));
#line 636 "recordings.ecpp"
    _tnt_cq22.add( "flat", (flat));
#line 636 "recordings.ecpp"
    _tnt_cq22.add( "history_num_back", (history_num_back));
#line 636 "recordings.ecpp"
    _tnt_cq22.add( "id", (id));
#line 636 "recordings.ecpp"
    _tnt_cq22.add( "sort", (sort));
#line 636 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[180]; // \n
  // <& recordings.del_rec ...
  { 
#line 637 "recordings.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 637 "recordings.ecpp"
    _tnt_cq23.add( "filter", (filter));
#line 637 "recordings.ecpp"
    _tnt_cq23.add( "flat", (flat));
#line 637 "recordings.ecpp"
    _tnt_cq23.add( "history_num_back", (history_num_back));
#line 637 "recordings.ecpp"
    _tnt_cq23.add( "id", (id));
#line 637 "recordings.ecpp"
    _tnt_cq23.add( "sort", (sort));
#line 637 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[181]; // \n
#line 638 "recordings.ecpp"

const cRecording* recording = NULL;
if (!id.empty()) recording = LiveRecordingsManager()->GetByMd5Hash(id);
if (recording && recording->Info() ) {
  int recordingErrors = -1;
#if VDRVERSNUM >= 20505
  recordingErrors = recording->Info()->Errors();
#endif
  const char *sdhd = nullptr;
  cToSvConcat frameParams;
#if VDRVERSNUM >= 20605
  StringAppendFrameParams(frameParams, recording);
  switch (recording->Info()->FrameWidth()) {
    case 720:
      sdhd = "720x576";
      break;
    case 1280:
      sdhd = "1280x720";
      break;
    case 1920:
      sdhd = "1920x1080";
      break;
    case 3840:
      sdhd = "3840x2160";
      break;
    default:
      break;
  }
#endif

  cGetScraperVideo getScraperVideo(NULL, recording);
  bool scraperDataAvailable = getScraperVideo.call(LiveSetup().GetPluginTvscraper());
  if (scraperDataAvailable) {
    int video_SD_HD = getScraperVideo.m_scraperVideo->getHD();
    if (!sdhd) sdhd = video_SD_HD == 0 ? "sd": video_SD_HD == 1 ? "hd": "ud";
    cToSvConcat<0> duration;
    if (recording->FileName() )
      AppendDuration(duration, tr("%d:%02d"), recording->LengthInSeconds() );

  reply.out() << _tntChunks[182]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 678 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[183]; // "></span>\n<script class="injectIcons">\ninjectErrorHdSdIcon("icons-
#line 680 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[184]; // ", 
#line 680 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(recordingErrors)));
  reply.out() << _tntChunks[185]; // , 
#line 680 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(getScraperVideo.m_scraperVideo->getDurationDeviation())));
  reply.out() << _tntChunks[186]; // , "
#line 680 "recordings.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[187]; // ", "
#line 680 "recordings.ecpp"
  reply.sout() << (cSv(recording->Info()->ChannelName()));
  reply.out() << _tntChunks[188]; // ", "
#line 680 "recordings.ecpp"
  reply.sout() << (duration);
  reply.out() << _tntChunks[189]; // ", 
#line 680 "recordings.ecpp"
  reply.sout() << ( GetNumberOfTsFiles(recording) );
  reply.out() << _tntChunks[190]; // , "
#line 680 "recordings.ecpp"
  reply.sout() << (frameParams);
  reply.out() << _tntChunks[191]; // ")\n</script>\n
#line 682 "recordings.ecpp"

  }
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[194]; // <img src="
#line 695 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[195]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 695 "recordings.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 695 "recordings.ecpp"
    _tnt_cq24.add( "text", (archived));
#line 695 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[196]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 696 "recordings.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 696 "recordings.ecpp"
    _tnt_cq25.add( "s_IMDB_ID", (s_IMDB_ID));
#line 696 "recordings.ecpp"
    _tnt_cq25.add( "title", (title));
#line 696 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[197]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 701 "recordings.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 701 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[200]; // \n
#line 702 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
