////////////////////////////////////////////////////////////////////////
// setup.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.setup")

// <%pre>
#line 1 "setup.ecpp"


#include <setup.h>
#include <stringhelpers.h>
#include <tools.h>
#include <users.h>
#include <live.h>
#include <livefeatures.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("setup");

static const char* rawData = "D\001\000\000\262\001\000\000\277\001\000\000\304\001\000\000)\004\000\000.\004\000\000"
  "\256\004\000\000\366\004\000\000\302\005\000\0007\006\000\000\260\006\000\000\255\007\000\000\365\007\000\000\213\010"
  "\000\000\327\010\000\000\215\t\000\000\n\n\000\000w\n\000\000\306\n\000\000\355\n\000\000T\013\000\000\247\013\000"
  "\000\302\013\000\000\322\013\000\0009\014\000\000\220\014\000\000B\015\000\000\275\015\000\000/\016\000\000\260\016"
  "\000\000\325\016\000\000\"\017\000\000\245\017\000\000C\020\000\000\267\020\000\000*\021\000\000\273\021\000\000\356"
  "\021\000\000!\022\000\000S\022\000\000\206\022\000\000\307\022\000\000V\023\000\000#\024\000\000\327\024\000\000R\025"
  "\000\000\304\025\000\000)\026\000\000\241\026\000\000\366\026\000\000\024\027\000\000w\027\000\000\324\027\000\000"
  "\372\027\000\000]\030\000\000\321\030\000\000]\031\000\000\364\031\000\000g\032\000\000\364\032\000\000\365\032\000"
  "\000)\033\000\000*\033\000\000[\033\000\000\134\033\000\000\222\033\000\000\223\033\000\000\306\033\000\000\307\033"
  "\000\000\366\033\000\000\367\033\000\000y\034\000\000\321\034\000\000\356\034\000\000\360\034\000\000\361\034\000\000"
  "\373\034\000\000\347\035\000\000e\036\000\000f\036\000\000g\036\000\000\n<html>\n  <head>\n<meta name=\"viewport\" co"
  "ntent=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - </title>\n    \n    \n    <script type=\"text"
  "/javascript\"><!--\n    function initform()\n    {\n      changeduseauth(document.getElementById(\"useauth\"));\n    "
  "  if (document.getElementById(\"message\").value != \"\")\n        alert(document.getElementById(\"message\").value);"
  "\n    }\n    function changeduseauth(selection)\n    {\n      document.getElementById(\"authsection\").style.display "
  "= (selection.checked \? \"block\" : \"none\");\n    }\n    function setauthchanged(selection)\n    {\n      document."
  "getElementById(\"authchanged\").value = 1;\n    }\n    //--></script>\n  </head>\n  <body onload=\"initform(); adjust"
  "Header()\" onresize=\"adjustHeader()\">\n    \n    \n    <div class=\"inhalt\">\n      <form method=\"post\" action="
  "\"setup.html\">\n        <input type=\"hidden\" name=\"authchanged\" value=\"\" id=\"authchanged\"/>\n        <input "
  "type=\"hidden\" name=\"message\" value=\"\" id=\"message\"/>\n        <table class=\"formular\" cellpadding=\"0\" cel"
  "lspacing=\"0\">\n          <tr class=\"head\">\n            <td  class=\"toprow leftcol rightcol\" colspan=\"2\"><div"
  " class=\"boxheader\"><div><div></div></div></div></td>\n          </tr>\n          <tr>\n            <td class=\"labe"
  "l leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\">\n              <input type=\""
  "checkbox\" name=\"useauth\" id=\"useauth\" value=\"1\" onclick=\"changeduseauth(this)\"/>\n              <div id=\"au"
  "thsection\" style=\"display: none\">\n              <table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"d"
  "ependent\">\n              <tr>\n                <td class=\"label\"><div class=\"withmargin\">:</div></td>\n        "
  "        <td><input type=\"text\" name=\"login\" value=\"\" id=\"login\" onchange=\"setauthchanged(this)\" /></td>\n  "
  "            </tr>\n              <tr>\n                <td class=\"label\"><div class=\"withmargin\">:</div></td>\n  "
  "              <td><input  type=\"password\" name=\"pass\" value=\"\" id=\"pass\" onchange=\"setauthchanged(this)\" />"
  "</td>\n              </tr>\n              <tr>\n                <td colspan=\"2\" class=\"label\"><div class=\"withma"
  "rgin\"><a href=\"users.html\"></a></div></td>\n              </tr>\n              <tr>\n                <td colspan="
  "\"2\" class=\"label\"><div class=\"withmargin\"></div></td>\n              </tr>\n              <tr>\n               "
  " <td class=\"label\"><div class=\"withmargin\">:</div></td>\n                <td><input type=\"text\" name=\"localnet"
  "mask\" value=\"\" id=\"localnetmask\" />\n                </td>\n              </tr>\n              <tr>\n           "
  "     <td class=\"label\"><div class=\"withmargin\">:</div></td>\n                <td><input type=\"text\" name=\"loca"
  "lnetmaskIPv6\" value=\"\" id=\"localnetmaskIPv6\" />\n                </td>\n              </tr>\n              <tr>"
  "\n                <td class=\"label\"><div class=\"withmargin\">:</div></td>\n                <td><input type=\"check"
  "box\" name=\"allowlocalhost\" value=\"1\"/>\n              </tr>\n              </table>\n              </div>\n     "
  "       </td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</d"
  "iv></td>\n            <td class=\"rightcol\">\n              <input type=\"checkbox\" name=\"showLogo\" id=\"showLogo"
  "\" value=\"1\"/>\n            </td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div cl"
  "ass=\"withmargin\">:</div></td>\n            <td class=\"rightcol\">\n              <input type=\"checkbox\" name=\"s"
  "howInfoBox\" id=\"showInfoBox\" value=\"1\"/>\n            </td>\n          </tr>\n          <tr>\n            <td cl"
  "ass=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\">\n              <inp"
  "ut type=\"checkbox\" name=\"useStreamdev\" id=\"useStreamdev\" value=\"1\" onclick=\"changedusestreamdev(this)\"/>\n "
  "           </td>\n          </tr>\n              <tr>\n                <td class=\"label leftcol\"><div class=\"withm"
  "argin\">:</div></td>\n                <td class=\"rightcol\"><input type=\"text\" name=\"streamdevport\" id=\"streamd"
  "evport\" value=\"\" /></td>\n              </tr>\n              <tr>\n                <td class=\"label leftcol\"><di"
  "v class=\"withmargin\">:</div></td>\n                <td class=\"rightcol\"><select name=\"streamdevtype\" size=\"1\""
  " id=\"streamdevtype\">\n                  <option value=\"TS\" >TS</option>\n                  <option value=\"PES\" "
  ">PES</option>\n                  <option value=\"PS\" >PS</option>\n                  <option value=\"ES\" >ES</optio"
  "n>\n                  <option value=\"EXT\" >EXT</option>\n                </select></td>\n              </tr>\n     "
  "                                   <tr>\n                                                <td class=\"label leftcol\">"
  "<div class=\"withmargin\">:</div></td>\n                                                <td class=\"rightcol\">\n    "
  "                                                    <input type=\"checkbox\" name=\"markNewRec\" id=\"markNewRec\" va"
  "lue=\"1\"/>\n                                                </td>\n                                        </tr>\n  "
  "        <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class="
  "\"rightcol\">\n              <input type=\"checkbox\" name=\"showIMDb\" id=\"showIMDb\" value=\"1\"/>\n            </"
  "td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>"
  "\n            <td class=\"rightcol\"><input type=\"number\" min=\"0\" name=\"lastchannel\" value=\"\" id=\"lastchanne"
  "l\" /></td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</di"
  "v></td>\n            <td class=\"rightcol\"><input type=\"text\" name=\"times\" value=\"\" id=\"times\" />\n         "
  "     </td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div"
  "></td>\n            <td class=\"rightcol\"><input type=\"text\" name=\"channelGroups\" value=\"\" id=\"channelGroups"
  "\" />\n              </td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"wit"
  "hmargin\">:</div></td>\n            <td class=\"rightcol\"><input type=\"number\" min=\"1\" max= \"23\" name=\"schedu"
  "leDuration\" value=\"\" id=\"scheduleDuration\" />\n              </td>\n          </tr>\n          <tr>\n           "
  " <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\">\n           "
  "   <input type=\"checkbox\" name=\"showChannelsWithoutEPG\" id=\"showChannelsWithoutEPG\" value=\"1\"/>\n            "
  "</td>\n          </tr>\n\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></"
  "td>\n            <td class=\"rightcol\"><select name=\"startscreen\" size=\"1\" id=\"startscreen\">\n              <o"
  "ption value=\"whatsonnow\" ></option>\n              <option value=\"whatsonnext\" ></option>\n              <option "
  "value=\"schedule\" ></option>\n              <option value=\"multischedule\" ></option>\n              <option value="
  "\"recordings\" ></option>\n              <option value=\"timers\" ></option>\n            </select></td>\n          <"
  "/tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td"
  " class=\"rightcol\"><select name=\"theme\" size=\"1\" id=\"theme\">\n              <option value=\"\" ></option>\n   "
  "         </select></td>\n          </tr>\n          <tr>\n            <td class=\"buttonpanel leftcol rightcol bottom"
  "row\" colspan=\"2\">\n              <div class=\"withmargin\">\n              <button class=\"green\" type=\"submit\""
  " name=\"save\" ></button>\n              </div>\n            </td>\n          </tr>\n        </table>\n      </form>"
  "\n    </div>\n  </body>\n</html>\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("setup " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string lastchannel = qparam.get< std::string >("lastchannel");
bool useauth = qparam.get< bool >("useauth", ( false));
std::string login = qparam.get< std::string >("login");
std::string pass = qparam.get< std::string >("pass");
std::string times = qparam.get< std::string >("times");
std::string channelGroups = qparam.get< std::string >("channelGroups");
std::string scheduleDuration = qparam.get< std::string >("scheduleDuration");
std::string startscreen = qparam.get< std::string >("startscreen");
std::string theme = qparam.get< std::string >("theme");
std::string localnetmask = qparam.get< std::string >("localnetmask");
std::string localnetmaskIPv6 = qparam.get< std::string >("localnetmaskIPv6");
std::string allowlocalhost = qparam.get< std::string >("allowlocalhost");
std::string showLogo = qparam.get< std::string >("showLogo");
std::string showInfoBox = qparam.get< std::string >("showInfoBox");
std::string useStreamdev = qparam.get< std::string >("useStreamdev");
std::string markNewRec = qparam.get< std::string >("markNewRec");
std::string showIMDb = qparam.get< std::string >("showIMDb");
std::string showChannelsWithoutEPG = qparam.get< std::string >("showChannelsWithoutEPG");
std::string streamdevport = qparam.get< std::string >("streamdevport");
std::string streamdevtype = qparam.get< std::string >("streamdevtype");
int authchanged = qparam.get< int >("authchanged", ( 0));
  // </%args>

#line 37 "setup.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 40 "setup.ecpp"

if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat<0> targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}
if (!cUser::CurrentUserHasRightTo(UR_EDITSETUP))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

#define SELECTIF(x) reply.out() << ( (x) ? "selected=\"selected\"" : "" );
#define CHECKIF(x) reply.out() << ( (x) ? " checked=\"checked\"" : "" );

  std::string message;

  if ( request.getMethod() == "POST") {
    if (authchanged && useauth && (login.empty() || pass.empty()))
      message = tr("Please set login and password!");
    else
    {
      LiveSetup().SetLastChannel(lastchannel != "" ? parse_int<int>(lastchannel):0);
      LiveSetup().SetUseAuth(useauth);
      if (useauth) {
        LiveSetup().SetAdminLogin(login);
        if (pass != "")
          LiveSetup().SetAdminPassword(pass);
        LiveSetup().SetLocalNetMask(localnetmask);
        LiveSetup().SetLocalNetMaskIPv6(localnetmaskIPv6);
        LiveSetup().SetAllowLocalhost(!allowlocalhost.empty());
        LiveSetup().CheckLocalNet(request.getPeerIp());
      }
      LiveSetup().SetTimes(times);
      LiveSetup().SetChannelGroups(channelGroups);
      LiveSetup().SetScheduleDuration(scheduleDuration);
      LiveSetup().SetStartScreen(startscreen);
      LiveSetup().SetTheme(theme);
      LiveSetup().SetShowLogo(!showLogo.empty());
      LiveSetup().SetShowInfoBox(!showInfoBox.empty());
      LiveSetup().SetUseStreamdev(!useStreamdev.empty());
      LiveSetup().SetStreamdevPort(streamdevport.empty() ? 3000 : parse_int<int>(streamdevport));
      LiveSetup().SetStreamdevType(streamdevtype.empty() ? "PES" : streamdevtype);
      LiveSetup().SetMarkNewRec(!markNewRec.empty());

      LiveSetup().SetShowIMDb(!showIMDb.empty());
      LiveSetup().SetShowChannelsWithoutEPG(!showChannelsWithoutEPG.empty());
      LiveSetup().SaveSetup();

      message = tr("Setup saved.");
    }
  }
  pageTitle = tr("Setup");
  int ilastchannel = LiveSetup().GetLastChannel();
  if (ilastchannel == std::numeric_limits< int >::max())
    lastchannel = "";
  else
    lastchannel = std::string(cToSvInt(ilastchannel));

  login = LiveSetup().GetAdminLogin();
  useauth = LiveSetup().GetUseAuth();
  times = LiveSetup().GetTimes();
  channelGroups = LiveSetup().GetChannelGroups();
  scheduleDuration = LiveSetup().GetScheduleDuration();
  startscreen = LiveSetup().GetStartScreen();
  theme = LiveSetup().GetTheme();
  localnetmask = LiveSetup().GetLocalNetMask();
  localnetmaskIPv6 = LiveSetup().GetLocalNetMaskIPv6();
  allowlocalhost = LiveSetup().GetAllowLocalhost() ? "1" : "";
  showLogo = LiveSetup().GetShowLogo() ? "1" : "";
  showInfoBox = LiveSetup().GetShowInfoBox() ? "1" : "";
  useStreamdev = LiveSetup().GetUseStreamdev() ? "1" : "";
  streamdevport = std::string(cToSvInt(LiveSetup().GetStreamdevPort()));
  streamdevtype = LiveSetup().GetStreamdevType();
  markNewRec = LiveSetup().GetMarkNewRec() ? "1" : "";
  showIMDb = LiveSetup().GetShowIMDb() ? "1" : "";
  showChannelsWithoutEPG = LiveSetup().GetShowChannelsWithoutEPG() ? "1" : "";

  // <& pageelems.doc_type ...
  { 
#line 115 "setup.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 115 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n  <head>\n<meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 119 "setup.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 120 "setup.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 120 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 121 "setup.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 121 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n    <script type="text/javascript"><!--\n    function initform()\n    {\n      changeduseauth(document.getElementById("useauth"));\n      if (document.getElementById("message").value != "")\n        alert(document.getElementById("message").value);\n    }\n    function changeduseauth(selection)\n    {\n      document.getElementById("authsection").style.display = (selection.checked \? "block" : "none");\n    }\n    function setauthchanged(selection)\n    {\n      document.getElementById("authchanged").value = 1;\n    }\n    //--></script>\n  </head>\n  <body onload="initform(); adjustHeader()" onresize="adjustHeader()">\n    
  // <& pageelems.logo ...
  { 
#line 140 "setup.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 140 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    
  // <& menu ...
  { 
#line 141 "setup.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 141 "setup.ecpp"
    _tnt_cq4.add( "active", ("setup"));
#line 141 "setup.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    <div class="inhalt">\n      <form method="post" action="setup.html">\n        <input type="hidden" name="authchanged" value="
#line 144 "setup.ecpp"
  reply.sout() << ( authchanged );
  reply.out() << _tntChunks[6]; // " id="authchanged"/>\n        <input type="hidden" name="message" value="
#line 145 "setup.ecpp"
  reply.sout() << ( message );
  reply.out() << _tntChunks[7]; // " id="message"/>\n        <table class="formular" cellpadding="0" cellspacing="0">\n          <tr class="head">\n            <td  class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div><div>
#line 148 "setup.ecpp"
  reply.sout() << ( tr("Setup") );
  reply.out() << _tntChunks[8]; // </div></div></div></td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 151 "setup.ecpp"
  reply.sout() << ( tr("Use authentication") );
  reply.out() << _tntChunks[9]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="useauth" id="useauth" value="1"
#line 153 "setup.ecpp"
 CHECKIF(useauth); 
  reply.out() << _tntChunks[10]; //  onclick="changeduseauth(this)"/>\n              <div id="authsection" style="display: none">\n              <table border="0" cellpadding="0" cellspacing="0" class="dependent">\n              <tr>\n                <td class="label"><div class="withmargin">
#line 157 "setup.ecpp"
  reply.sout() << ( tr("Admin login") );
  reply.out() << _tntChunks[11]; // :</div></td>\n                <td><input type="text" name="login" value="
#line 158 "setup.ecpp"
  reply.sout() << ( login );
  reply.out() << _tntChunks[12]; // " id="login" onchange="setauthchanged(this)" /></td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 161 "setup.ecpp"
  reply.sout() << ( tr("Admin password") );
  reply.out() << _tntChunks[13]; // :</div></td>\n                <td><input  type="password" name="pass" value="
#line 162 "setup.ecpp"
  reply.sout() << ( pass );
  reply.out() << _tntChunks[14]; // " id="pass" onchange="setauthchanged(this)" /></td>\n              </tr>\n              <tr>\n                <td colspan="2" class="label"><div class="withmargin"><a href="users.html">
#line 165 "setup.ecpp"
  reply.sout() << ( tr("User management") );
  reply.out() << _tntChunks[15]; // </a></div></td>\n              </tr>\n              <tr>\n                <td colspan="2" class="label"><div class="withmargin">
#line 168 "setup.ecpp"
  reply.sout() << ( tr("Local net (no login required)") );
  reply.out() << _tntChunks[16]; // </div></td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 171 "setup.ecpp"
  reply.sout() << ( tr("IPv4 prefix") );
  reply.out() << _tntChunks[17]; // :</div></td>\n                <td><input type="text" name="localnetmask" value="
#line 172 "setup.ecpp"
  reply.sout() << ( localnetmask );
  reply.out() << _tntChunks[18]; // " id="localnetmask" />\n                
  // <& tooltip.help ...
  { 
#line 173 "setup.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 173 "setup.ecpp"
    _tnt_cq5.add( "text", (tr("Example: 192.168.178.0/24")));
#line 173 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[19]; // </td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 176 "setup.ecpp"
  reply.sout() << ( tr("IPv6 prefix") );
  reply.out() << _tntChunks[20]; // :</div></td>\n                <td><input type="text" name="localnetmaskIPv6" value="
#line 177 "setup.ecpp"
  reply.sout() << ( localnetmaskIPv6 );
  reply.out() << _tntChunks[21]; // " id="localnetmaskIPv6" />\n
#line 178 "setup.ecpp"
               // the mootools unfortunately use "::" as separator for title and text,

#line 179 "setup.ecpp"
               // so we need to escape this by inserting an invisible space U+200B in-between

  reply.out() << _tntChunks[22]; //                 
  // <& tooltip.help ...
  { 
#line 180 "setup.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 180 "setup.ecpp"
    _tnt_cq6.add( "text", (tr("Example: 2003:ec:6f23:ee00:&#x200B;:/64")));
#line 180 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[23]; // </td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 183 "setup.ecpp"
  reply.sout() << ( tr("Allow localhost") );
  reply.out() << _tntChunks[24]; // :</div></td>\n                <td><input type="checkbox" name="allowlocalhost" value="1"
#line 184 "setup.ecpp"
 CHECKIF(!allowlocalhost.empty()); 
  reply.out() << _tntChunks[25]; // />\n              </tr>\n              </table>\n              </div>\n            </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 191 "setup.ecpp"
  reply.sout() << ( tr("Show live logo image") );
  reply.out() << _tntChunks[26]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showLogo" id="showLogo" value="1"
#line 193 "setup.ecpp"
 CHECKIF(!showLogo.empty()); 
  reply.out() << _tntChunks[27]; // />\n            </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 197 "setup.ecpp"
  reply.sout() << ( tr("Show dynamic VDR information box") );
  reply.out() << _tntChunks[28]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showInfoBox" id="showInfoBox" value="1"
#line 199 "setup.ecpp"
 CHECKIF(!showInfoBox.empty()); 
  reply.out() << _tntChunks[29]; // />\n            </td>\n          </tr>\n
#line 202 "setup.ecpp"
 if (LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[30]; //           <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 204 "setup.ecpp"
  reply.sout() << ( tr("Allow video streaming") );
  reply.out() << _tntChunks[31]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="useStreamdev" id="useStreamdev" value="1"
#line 206 "setup.ecpp"
 CHECKIF(!useStreamdev.empty()); 
  reply.out() << _tntChunks[32]; //  onclick="changedusestreamdev(this)"/>\n            </td>\n          </tr>\n              <tr>\n                <td class="label leftcol"><div class="withmargin">
#line 210 "setup.ecpp"
  reply.sout() << ( tr("Streamdev server port") );
  reply.out() << _tntChunks[33]; // :</div></td>\n                <td class="rightcol"><input type="text" name="streamdevport" id="streamdevport" value="
#line 211 "setup.ecpp"
  reply.sout() << ( streamdevport );
  reply.out() << _tntChunks[34]; // " /></td>\n              </tr>\n              <tr>\n                <td class="label leftcol"><div class="withmargin">
#line 214 "setup.ecpp"
  reply.sout() << ( tr("Streamdev stream type") );
  reply.out() << _tntChunks[35]; // :</div></td>\n                <td class="rightcol"><select name="streamdevtype" size="1" id="streamdevtype">\n                  <option value="TS" 
#line 216 "setup.ecpp"
 SELECTIF(streamdevtype == "TS") 
  reply.out() << _tntChunks[36]; // >TS</option>\n                  <option value="PES" 
#line 217 "setup.ecpp"
 SELECTIF(streamdevtype == "PES") 
  reply.out() << _tntChunks[37]; // >PES</option>\n                  <option value="PS" 
#line 218 "setup.ecpp"
 SELECTIF(streamdevtype == "PS") 
  reply.out() << _tntChunks[38]; // >PS</option>\n                  <option value="ES" 
#line 219 "setup.ecpp"
 SELECTIF(streamdevtype == "ES") 
  reply.out() << _tntChunks[39]; // >ES</option>\n                  <option value="EXT" 
#line 220 "setup.ecpp"
 SELECTIF(streamdevtype == "EXT") 
  reply.out() << _tntChunks[40]; // >EXT</option>\n                </select></td>\n              </tr>\n
#line 223 "setup.ecpp"
 }   // endif LiveFeatures<features::streamdev_server>().Loaded()

  reply.out() << _tntChunks[41]; //                                         <tr>\n                                                <td class="label leftcol"><div class="withmargin">
#line 225 "setup.ecpp"
  reply.sout() << ( tr("Mark new recordings") );
  reply.out() << _tntChunks[42]; // :</div></td>\n                                                <td class="rightcol">\n                                                        <input type="checkbox" name="markNewRec" id="markNewRec" value="1"
#line 227 "setup.ecpp"
 CHECKIF(!markNewRec.empty()); 
  reply.out() << _tntChunks[43]; // />\n                                                </td>\n                                        </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 231 "setup.ecpp"
  reply.sout() << ( tr("Show link to IMDb in list views") );
  reply.out() << _tntChunks[44]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showIMDb" id="showIMDb" value="1"
#line 233 "setup.ecpp"
 CHECKIF(!showIMDb.empty()); 
  reply.out() << _tntChunks[45]; // />\n            </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 237 "setup.ecpp"
  reply.sout() << ( tr("Last channel to display") );
  reply.out() << _tntChunks[46]; // :</div></td>\n            <td class="rightcol"><input type="number" min="0" name="lastchannel" value="
#line 238 "setup.ecpp"
  reply.sout() << ( lastchannel );
  reply.out() << _tntChunks[47]; // " id="lastchannel" /></td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 241 "setup.ecpp"
  reply.sout() << ( tr("Additional fixed times in 'What's on?'") );
  reply.out() << _tntChunks[48]; // :</div></td>\n            <td class="rightcol"><input type="text" name="times" value="
#line 242 "setup.ecpp"
  reply.sout() << ( times );
  reply.out() << _tntChunks[49]; // " id="times" />\n              
  // <& tooltip.help ...
  { 
#line 243 "setup.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 243 "setup.ecpp"
    _tnt_cq7.add( "text", (tr("Format is HH:MM. Separate multiple times with a semicolon")));
#line 243 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[50]; // </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 246 "setup.ecpp"
  reply.sout() << ( tr("Channel groups for MultiSchedule") );
  reply.out() << _tntChunks[51]; // :</div></td>\n            <td class="rightcol"><input type="text" name="channelGroups" value="
#line 247 "setup.ecpp"
  reply.sout() << ( channelGroups );
  reply.out() << _tntChunks[52]; // " id="channelGroups" />\n              
  // <& tooltip.help ...
  { 
#line 248 "setup.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 248 "setup.ecpp"
    _tnt_cq8.add( "text", (tr("Separate channels with a comma ',', separate groups with a semi-colon ';'")));
#line 248 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[53]; // </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 251 "setup.ecpp"
  reply.sout() << ( tr("Duration of MultiSchedule in hours") );
  reply.out() << _tntChunks[54]; // :</div></td>\n            <td class="rightcol"><input type="number" min="1" max= "23" name="scheduleDuration" value="
#line 252 "setup.ecpp"
  reply.sout() << ( scheduleDuration );
  reply.out() << _tntChunks[55]; // " id="scheduleDuration" />\n              </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 256 "setup.ecpp"
  reply.sout() << ( tr("Show channels without EPG") );
  reply.out() << _tntChunks[56]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showChannelsWithoutEPG" id="showChannelsWithoutEPG" value="1"
#line 258 "setup.ecpp"
 CHECKIF(!showChannelsWithoutEPG.empty()); 
  reply.out() << _tntChunks[57]; // />\n            </td>\n          </tr>\n\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 263 "setup.ecpp"
  reply.sout() << ( tr("Start page") );
  reply.out() << _tntChunks[58]; // :</div></td>\n            <td class="rightcol"><select name="startscreen" size="1" id="startscreen">\n              <option value="whatsonnow" 
#line 265 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnow") 
  reply.out() << _tntChunks[59]; // >
#line 265 "setup.ecpp"
  reply.sout() << ( trVDR("What's on now?") );
  reply.out() << _tntChunks[60]; // </option>\n              <option value="whatsonnext" 
#line 266 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnext") 
  reply.out() << _tntChunks[61]; // >
#line 266 "setup.ecpp"
  reply.sout() << ( trVDR("What's on next?") );
  reply.out() << _tntChunks[62]; // </option>\n              <option value="schedule" 
#line 267 "setup.ecpp"
 SELECTIF(startscreen == "schedule") 
  reply.out() << _tntChunks[63]; // >
#line 267 "setup.ecpp"
  reply.sout() << ( trVDR("Schedule") );
  reply.out() << _tntChunks[64]; // </option>\n              <option value="multischedule" 
#line 268 "setup.ecpp"
 SELECTIF(startscreen == "multischedule") 
  reply.out() << _tntChunks[65]; // >
#line 268 "setup.ecpp"
  reply.sout() << ( tr("MultiSchedule") );
  reply.out() << _tntChunks[66]; // </option>\n              <option value="recordings" 
#line 269 "setup.ecpp"
 SELECTIF(startscreen == "recordings") 
  reply.out() << _tntChunks[67]; // >
#line 269 "setup.ecpp"
  reply.sout() << ( trVDR("Recordings") );
  reply.out() << _tntChunks[68]; // </option>\n              <option value="timers" 
#line 270 "setup.ecpp"
 SELECTIF(startscreen == "timers") 
  reply.out() << _tntChunks[69]; // >
#line 270 "setup.ecpp"
  reply.sout() << ( trVDR("Timers") );
  reply.out() << _tntChunks[70]; // </option>\n            </select></td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 274 "setup.ecpp"
  reply.sout() << ( tr("Theme") );
  reply.out() << _tntChunks[71]; // :</div></td>\n            <td class="rightcol"><select name="theme" size="1" id="theme">\n
#line 276 "setup.ecpp"

{
  const std::string dirPath(Plugin::GetResourceDirectory() + "/themes");
  cReadDir d(dirPath.c_str());
  struct dirent* e;
  std::string parent("..");
  std::string current(".");
  std::string cvsDir("CVS");
  while ((e = d.Next())) {
    if ((current == e->d_name) || (parent == e->d_name) || (cvsDir == e->d_name)) {
      continue;
    }
    /* Check if entry is a directory: I do not rely on e->d_type
       here because on some systems it is allways DT_UNKNOWN. Also
       testing for DT_DIR does not take into account symbolic
       links to directories.
    */
    struct stat buf;
    if ((stat((dirPath + "/" + e->d_name).c_str(), &buf) != 0) || (!S_ISDIR(buf.st_mode))) {
      continue;
    }

  reply.out() << _tntChunks[72]; //               <option value="
#line 298 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << _tntChunks[73]; // " 
#line 298 "setup.ecpp"
 SELECTIF(theme == e->d_name) 
  reply.out() << _tntChunks[74]; // >
#line 298 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << _tntChunks[75]; // </option>\n
#line 299 "setup.ecpp"

  }
}

  reply.out() << _tntChunks[76]; //             </select></td>\n          </tr>\n          <tr>\n            <td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n              <div class="withmargin">\n              <button class="green" type="submit" name="save" >
#line 308 "setup.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << _tntChunks[77]; // </button>\n              </div>\n            </td>\n          </tr>\n        </table>\n      </form>\n    </div>\n  </body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[78]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[79]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
