////////////////////////////////////////////////////////////////////////
// switch_channel.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.switch_channel")

// <%pre>
#line 1 "switch_channel.ecpp"


#include <exception.h>
#include <setup.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("switch_channel");

static const char* rawData = "\030\000\000\000E\000\000\000T\000\000\000c\000\000\000j\000\000\000k\000\000\000<b>Switc"
  "h-Channel Request</b>\n<hr/>\nChannel: <br/>\nResult:  <br/>\nError:   \n<hr/>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("switch_channel " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int channel_number = qparam.get< int >("channel_number", ( 0));
std::string param = qparam.get< std::string >("param");
std::string async = qparam.get< std::string >("async");
  // </%args>

#line 18 "switch_channel.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
#line 20 "switch_channel.ecpp"

  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }
  tChannelID channelID;
  if (qparam.has("channel_number") && channel_number > 0) {
    LOCK_CHANNELS_READ;
    const cChannel* channel = Channels->GetByNumber(channel_number);
    channelID = channel ? channel->GetChannelID() : tChannelID::InvalidID;
  } else
    channelID = tChannelID::FromString(param.c_str());

  bool ajaxReq = !async.empty() && (parse_int<int>(async) != 0);
  std::string referrer;

  if (!cUser::CurrentUserHasRightTo(UR_SWITCHCHNL))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

  if (ajaxReq) {
    reply.setContentType( "application/xml" );
  }
  else {
    referrer = request.getHeader("Referer:");
  }

  SwitchChannelTask task( channelID );
  LiveTaskManager().Execute( task );

  if (!ajaxReq) {
    if (!referrer.empty() && referrer.find("login") == std::string::npos) {
      return reply.redirect(referrer);
    }

  reply.out() << _tntChunks[0]; // <b>Switch-Channel Request</b>\n<hr/>\nChannel: 
#line 57 "switch_channel.ecpp"
  reply.sout() << ( channelID );
#line 57 "switch_channel.ecpp"
  if ( qparam.has("channel_number") )
    reply.sout() <<  " [" + std::to_string(channel_number) + "]" ;
  reply.out() << _tntChunks[1]; // <br/>\nResult:  
#line 58 "switch_channel.ecpp"
  reply.sout() << ( task.Result() );
  reply.out() << _tntChunks[2]; // <br/>\nError:   
#line 59 "switch_channel.ecpp"
  reply.sout() << ( !task.Error().empty() ? task.Error() : "—" );
  reply.out() << _tntChunks[3]; // \n<hr/>\n
#line 61 "switch_channel.ecpp"

  }
  else {

  // <& xmlresponse.ajax ...
  { 
#line 65 "switch_channel.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 65 "switch_channel.ecpp"
    _tnt_cq0.add( "error", (task.Error()));
#line 65 "switch_channel.ecpp"
    _tnt_cq0.add( "name", ("switch_channel"));
#line 65 "switch_channel.ecpp"
    _tnt_cq0.add( "pname", ("channel"));
#line 65 "switch_channel.ecpp"
    _tnt_cq0.add( "result", (task.Result()));
#line 65 "switch_channel.ecpp"
    _tnt_cq0.add( "value", (channelID));
#line 65 "switch_channel.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ajax"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n
#line 66 "switch_channel.ecpp"

  }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
